#!/usr/local/bin/perl
#
# Program to open the file, read it in,
# print it, and close it again.

$file = './result';		# Name the file
open(RESULT, $file);	# Open the file
@lines = <RESULT>;		# Read it into an array
close(RESULT);			# Close the file

$outputFile = './outfile.txt';
open(OUT,">",$outputFile);
#print @lines;			# Print the array
$size = @lines;		# Size of the array
print "Number of lines in file: " . $size . "\n";

#print "Length: " . (length(@lines[0]) + length(@lines[1])) . " characters.\n";

# parse the whole file
for ($i = 0; $i < $size; $i++) {
  parseLine(@lines[$i]);
}
#print "Iterations: " . ($i) . "\n";

###################### cleanup
close(OUT);
print "\nDone!\nResult was written in file: ".$outputFile; 



###################### subroutines
sub parseLine() {
  local $line = shift;
  local $firstCommaIndex = index $line, ",";
  #get the timestep of the current line. 
  local $timestep = substr $line, 1, $firstCommaIndex-1;
  
  print OUT "[TIMESTEP(".$timestep."): ";
  #print "LI: " . $line;
  $line = createProperVariableNames($line);
  #print $line;
  #create the FORALL preambles
  parseFORALL($line);
  
  parseFormular(substr $line, $firstCommaIndex+2, length($line)-$firstCommaIndex-5);
  
  # do not forget the closing bracket and newline 
  print OUT "]\n";
  
}

sub parseFormular() {
  #get the current string that has to be parsed
  local $str = shift; 
  #print $str . "\n";
  
  $testVal = substr($str, 0, 2);
  if( $testVal eq "[ ") {
    #there is an implication to be handled
	
	#at first the two sides have to be seperated
	#cuts just out the tow sides of the implication. 9 = 8 (implication symbol) + 1 trailing bracket!
	$implicationSides = substr($str, 8, length($str)-9); 
	#print isBracketBalanced($implicationSides);
	
	#find the comma seperating the two sides
	$commaIndex=0;
	while(isBracketBalanced(substr $implicationSides, 0, $commaIndex) != 1){
		$commaIndex = index $implicationSides, ",", $commaIndex+1;
	}
	local $leftSide = substr($implicationSides, 0, $commaIndex);
	local $rightSide = substr($implicationSides, $commaIndex+2, length($implicationSides)-$commaIndex);
	#print ( $leftSide . "\n" . $rightSide . "\n");
	
	print OUT "(";
	
	parseFormular($leftSide);
	
	print OUT " -> ";
	
	parseFormular($rightSide);
	
	print OUT ")";
	
	
  } elsif( $testVal eq "[n") {
    #there is something negated
	
	#kill the not! 7 = 6 (not symbol lenght) + 1 trailing bracket
	$negFormular = substr($str, 6, length($str)-7); 
	#print $str . "\n" . $negFormular . "\n";
	print OUT ("NOT(");
	parseFormular($negFormular);
	print OUT (")");
	
	
  } elsif( $testVal eq "pr") {
    #there is a predicate here
	#it has to be one of the following: k, u, b, w
	local $predName = substr($str, 5, 1);
	
	if($predName eq "k") {
	  local $wiseman;
	  local $timestepVar;
	  local $formular;
	  
	  #get the wiseman
	  local $wisemanPos = (index($str,"[", 0)+1);
	  $wiseman = substr($str, $wisemanPos, (index($str, ",", $wisemanPos)-$wisemanPos)); 
	  
	  #get the timestepvariable
	  local $timestepVarPos = (index($str, ",", $wisemanPos)+2);
	  local $timestepVarEndPos; #position in $str where the timestepvariable ends!
	  #s(i) case?
	  if(substr($str, $timestepVarPos, 1) eq "[") {
	    $timestepVar = substr($str, $timestepVarPos+8,(index($str, ")", $timestepVarPos)-($timestepVarPos+8)));
		$timestepVar = ("s(".$timestepVar.")");
		$timestepVarEndPos = ((index($str, ")", $timestepVarPos)+4));
	  } elsif(substr($str, $timestepVarPos, 1) eq "a") {
	    #this is the case where there is an s(i) in the whole formular, and somewhere else a any(i)
		$timestepVar = substr($str, $timestepVarPos+4, (index($str, ")", $timestepVarPos)-($timestepVarPos+4)));
		$timestepVarEndPos = ((index($str, ")", $timestepVarPos)));
	  } else {
	    $timestepVar = substr($str, $timestepVarPos, (index($str, ",",$timestepVarPos)-($timestepVarPos)));
		$timestepVarEndPos = (index($str, ",",$timestepVarPos)-1);
	  }
	  
	  #get the formular that is known by the wiseman
	  local $knownFormularPos = $timestepVarEndPos+3;
	  local $knownFormular = substr($str, $knownFormularPos, ((length($str)-2)-$knownFormularPos)); #2 = one for the counting of arrays, 1 for the las two bracket that doesn't belong to the known formular.
	  
	  #print ("\nWiseman: ".$wiseman."\nTimestepvar: ".$timestepVar."\nFormular: ".$knownFormular);
	  print OUT ("K_".$wiseman."(".$timestepVar.", ");
	  
	  parseFormular($knownFormular); #."{".$knownFormular."}".
	  
	  print OUT (")");
	  
	} elsif ($predName eq "u") {
	  local $timestepVar;
	  local $utteredFormular;
	  
	  #find the timestepvariable
	  local $timestepVarEndPos; #position in $str where the timestepvariable ends!
	  local $timestepVarPos = 9;
	  
	  if(substr($str, $timestepVarPos, 1) eq "[") {
	    $timestepVar = substr($str, $timestepVarPos+8,(index($str, ")", $timestepVarPos)-($timestepVarPos+8)));
		$timestepVar = ("s(".$timestepVar.")");
		$timestepVarEndPos = ((index($str, ")", $timestepVarPos)+4));
	  } elsif(substr($str, $timestepVarPos, 1) eq "a") {
	    #this is the case where there is an s(i) in the whole formular, and somewhere else a any(i)
		$timestepVar = substr($str, $timestepVarPos+4, (index($str, ")", $timestepVarPos)-($timestepVarPos+4)));
		$timestepVarEndPos = ((index($str, ")", $timestepVarPos)));
	  } else {
	    $timestepVar = substr($str, $timestepVarPos, (index($str, ",",$timestepVarPos)-($timestepVarPos)));
		$timestepVarEndPos = (index($str, ",",$timestepVarPos)-1);
	  }
	  
	  local $utteredFormularPos = $timestepVarEndPos+3;
	  $utteredFormular = substr($str, $utteredFormularPos, ((length($str)-2)-$utteredFormularPos));
	  #print $str . "\n" . $timestepVar ."\n" . $utteredFormular."\n";
	  
	  print OUT ("U(".$timestepVar.", ");
	  
	  parseFormular($utteredFormular);
	  
	  print OUT (")");
	  
	} elsif ($predName eq "b") {
	  local $wisemanPos = 9; #is the length of "pred(b, [" which is then the index of the wiseman following the [ 
	  local $wiseman = substr($str, $wisemanPos, (index($str,"]",$wisemanPos)-$wisemanPos));
	  print OUT "B_".$wiseman;
	} elsif ($predName eq "w") {
	  local $wisemanPos = 9; #is the length of "pred(w, [" which is then the index of the wiseman following the [ 
	  local $wiseman = substr($str, $wisemanPos, (index($str,"]",$wisemanPos)-$wisemanPos));
	  print OUT "W_".$wiseman;
	} else {
   print "ERROR: " . $str;
  } 
	
    
  } elsif( $testVal eq "an") {
	#there was an implication with anys ... not sure that is 
	local $variable = substr($str, (index($str, "(",0)+1),(index($str, ")",0)-(index($str, "(",0)+1)) );
	print OUT $variable;
  } else {
   print "ERROR: " . $str;
  }
  
}

sub createProperVariableNames() {
  local $str = shift;
  
  local @handledCases;
  local @handledSICases;
  
  if ((index $str, "+", 0) == -1) {
	#there is no "any handling here!!
	#so the two predicates have to be handled: k, u. The second argument is always the variable name of the time point.
	#first let's handle the k's: 
	local $curPos = 0;
	local $varPos = 0;
	local $leftPart;
	local $rightPart;
	local $find;
	local $replace;
	
	while ($curPos != -1) {
	  $curPos = index $str, "pred(k,", $curPos;
	  if($curPos != -1){
	    $varPos = (index($str, ",", $curPos+7)+2);
	    $find = substr $str, $varPos, (index($str, ",", $varPos)-($varPos));
        $replace = createSVariableName($find);
		#cut out the old name and replace it with the new one!
	    $leftPart = substr($str, 0, $varPos);
	    $rightPart = substr($str, index($str, ",", $varPos), (length($str)-index($str, ",", $varPos)));
	    $str = ($leftPart . $replace . $rightPart);
		$curPos++;
	  } 
	} #end of k-handling
	
	#second, handle the u's:
	$curPos = 0;
	$varPos = 0;
	while($curPos != -1){
	  $curPos = index $str, "pred(u,", $curPos;
	  if($curPos != -1){
	    $varPos = $curPos + 9;
		$find = substr $str, $varPos, (index($str, ",", $varPos)-($varPos));
		$replace = createSVariableName($find);
		$leftPart = substr($str, 0, $varPos);
		$rightPart = substr($str, index($str, ",", $varPos), (length($str)-index($str, ",", $varPos)));
		$str = ($leftPart . $replace . $rightPart);
		
		$curPos++;
	  }
	}
	
  } else {
  ###################################### here the lines with FORALL preambles are handled....
  
  local $curPos = 0;
  while ($curPos != -1) {
    $curPos = index $str, "any(", $curPos;
	#print "CP:".$curPos . "\n";
	if($curPos != -1){
	  #check whether it is an s(i) case!
	  #if((substr $str, $curPos-3, 1) ne "+") {
		#print $str ."\n";
	    local $find = substr $str, $curPos, ((index $str, ")", $curPos)-$curPos)+1;
		local $notInTheList = 1; #flag to determine whether this one was already properly named...
		for $iter (0 .. $#handledCases) {
			if($find eq @handledCases[$iter]) {
				$notInTheList = 0;
			}
		}
		if($notInTheList == 1){
          
		  local $curVariableName = substr $str, $curPos+4, (((index $str, ")", $curPos))-($curPos+4));
		  local $replace = "any(x" . $curVariableName . ")";
          local $findMeta = quotemeta $find; # escape regex metachars if present
	    
		  #check wheter the current variable is an s(i) case! 
		  local $isSi = 0;
		  local $curPosSI = 0;
		  while($curPosSI != -1) {
		    $curPosSI = index $str, $find, $curPosSI;
		  
		    if($curPosSI != -1){
		      if ((substr $str, $curPosSI-3, 1) eq "+") {
			    $isSi = 1;
		      }
		      $curPosSI++;
		    }
		  }
		
		  if($isSi == 0) {
		    $str =~ s/$findMeta/$replace/g;
			@handledCases = (@handledCases, $replace);
		    #print $str ."\n";
		  } else {
		    #here the s(i) cases are handled.
			#at first a new variable name will be determined
			local $varName = 'i';
			local $notReady = 1;
			local $notInTheList = 1;
			
			while($notReady == 1){
			  
			  for $iter (0 .. $#handledSICases) {
			    if($varName eq @handledSICases[$iter]) {
				  $notInTheList = 0;
			    }
		      }
			  if($notInTheList == 1) {
			    $notReady = 0; #we found a free name! 
			  } else {
				$varName = chr(ord($varName)+1); #get another name to try on... 
			  }
			}
			
			#as there is a new variable name discovered here, we will just use it! 
			$replace = "any(" . $varName . ")";
			$str =~ s/$findMeta/$replace/g;
			@handledSICases = (@handledSICases, $replace);
			
			

		  }
		}
	  #} 
	  $curPos = ((index $str, $replace, $curPos)+1);
	}
	}
	#if((index $str, "u", 0) != -1){print "OOOOPS\n" . $str;}
	
  }

  return $str;
  
  

}

sub parseFORALL() {
  local $str = shift;
  local @handledCases;
  
  local $curPos = 0; 
  while ($curPos != -1) {
    $curPos = index $str, "any(", $curPos;
	#do we have got any any?
	if($curPos != -1) {
	  local $currentVariable = (substr $str, $curPos+4, (index $str, ")", $curPos)-($curPos+4));
	  
	  #already there?
	  local $notInTheList = 1; 
	  for $iter (0 .. $#handledCases) {
		if($currentVariable eq @handledCases[$iter]) {
		  $notInTheList = 0;
        }
	  }
	  if($notInTheList == 1) {
	    print OUT "FORALL(" . $currentVariable .")";
	    @handledCases = (@handledCases, $currentVariable); #add the current variable to the list of handled ones
	  }
	
	  $curPos++;
	}
  }
  
  if($#handledCases > -1) {
    print OUT " ";
  }
}

sub createSVariableName(){
  local $str = shift;
  local $ret;
  if($str eq "1") {
    $ret = "s(0)";
  } else {
    $ret = "s^".$str."(0)"; 
  }
  
  return $ret;
}

sub isBracketBalanced() {
  local $str = shift;
  
  local $openCnt=0;
  local $closedCnt=0;
  local $openSQCnt=0; 
  local $closeSQCnt=0;
  #get the number of bracktes in the provided string
  $openCnt = ($str =~ tr/(//);
  $closedCnt = ($str =~ tr/)//);
  
  $openSQCnt = ($str =~ tr/[//);
  $closedSQCnt = ($str =~ tr/]//);
  
  #print $openCnt . $closedCnt . $openSQCnt . $closedSQCnt ."\n";
  
  if($openCnt == $closedCnt && $openCnt != 0 && $closedCnt != 0 && $openSQCnt == $closedSQCnt){
    return 1;
  } else {
	return 0;
  }
}